unit f_test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TTest = class(TForm)
    Label1: TLabel;
    ePrj: TEdit;
    Label2: TLabel;
    eDbf: TEdit;
    btRun: TButton;
    mInfo: TMemo;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDlg: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure btRunClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
    procedure CBProc(Error: boolean; InfoStr, ErrStr: PChar);

  public
    { Public declarations }
  end;

var
  Test: TTest;

implementation

{$R *.dfm}

const
  sDLLNotFound='Dynamic library "%s" not found or corrupted.';

function GetAppPath: string;
begin
  Result:=(ExtractFilePath(AnsiLowerCase(Application.ExeName)));
end;

procedure TTest.FormShow(Sender: TObject);
begin
  ePrj.Text:=GetAppPath+'..\TestUpdate\update_v1.0.info';
  eDbf.Text:=GetAppPath+'..\DB_to_update\data.mdb';
  OpenDlg.InitialDir:=GetAppPath;
end;

procedure TTest.btRunClick(Sender: TObject);
const DLLFileName='mdbupdate.dll';
type
  TUpdCallBack= procedure (Error: boolean; InfoStr, ErrStr: PChar) of object;
  TRunMDBUpdate=function (ProjectFile,UpdateFile: PChar; UpdCallBack: TUpdCallBack): boolean; StdCall;

var DLLHandle: THandle;
    RunUpdate: TRunMDBUpdate;
begin
  Screen.Cursor:=crHourGlass;
  mInfo.Lines.Clear;
  try
    DLLHandle:=LoadLibrary(DLLFileName);
    if DLLHandle<=0 then ShowMessage(Format(sDLLNotFound,[DLLFileName]))
    else
    try
      @RunUpdate:=GetProcAddress(DLLHandle,'RunMDBUpdate');
      if @RunUpdate<>nil then
        if RunUpdate(PChar(ePrj.Text),PChar(eDBF.Text),CBProc) then
          ShowMessage('Update finished.');
    finally
      FreeLibrary(DLLHandle)
    end;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TTest.CBProc(Error: boolean; InfoStr, ErrStr: PChar);
begin
  mInfo.Lines.Add(InfoStr);
  if Error then
  begin
    mInfo.Lines.Add(ErrStr);
    ShowMessage(InfoStr+#13+ErrStr);
  end;
end;

procedure TTest.SpeedButton1Click(Sender: TObject);
begin
  OpenDlg.Filter:='DB Update INFO files (*.info)|*.info';
  if OpenDlg.Execute then
    ePrj.Text:=OpenDlg.FileName;
end;

procedure TTest.SpeedButton2Click(Sender: TObject);
begin
  OpenDlg.Filter:='MS Access files (*.mdb)|*.mdb';
  if OpenDlg.Execute then
    eDbf.Text:=OpenDlg.FileName;
end;

end.
